#lang play
(require "main.rkt")
(require "machine.rkt")


;; parse-type
(test (parse-type '{Num -> Num}) (TFun (TNum) (TNum)))
(test/exn (parse-type '{ -> Num}) "Parse error")


;; parse
(test (parse '{+ 1 3}) (add (num 1) (num 3)))
(test (parse '{with {x : Num 5} {+ x 3}}) (app (fun 'x (TNum) (add (id 'x) (num 3)) #f) (num 5)))


;; deBruijn
(test (deBruijn (num 3)) (num 3))
(test (deBruijn (parse '{with {x : Num 5}  {with  {y : Num  {+ x 1}} {+ y x}}}))
      (app (fun-db (app (fun-db (add (acc 0) (acc 1))) (add (acc 0) (num 1)))) (num 5)))
(test/exn (deBruijn (parse 'x)) "Free identifier: x")

;;compile
(test (compile (sub (add (num 2) (num 1)) (num 6))) (list (INT-CONST 6) (INT-CONST 1) (INT-CONST 2) (ADD) (SUB)))
(test (compile (my-if (bool #f) (num 1) (add (num 2) (num 1))) ) (list (BOOL-CONST #f) (IF (list (INT-CONST 1)) (list (INT-CONST 1) (INT-CONST 2) (ADD)))))


;;typeof
(test (typeof (parse '{+ 1 3})) (TNum))
(test/exn (typeof (parse '{fun {f : Num} : Bool 10}))
  "Type error")

;typed-compile
(test/exn (typed-compile '{if #t 2 #t})
      "Type error")

;typecheck
(test (typecheck '3) 'Num)